unit scanip;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, winsock;

type
  TCMSocketMessage = record
    Msg: Cardinal;
    Socket: TSocket;
    SelectEvent: Word;
    SelectError: Word;
    Result: Longint;
  end;

  TForm7 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Edit5: TEdit;
    Label6: TLabel;
    Edit6: TEdit;
    CheckBox1: TCheckBox;
    Button1: TButton;
    ListBox1: TListBox;
    Label7: TLabel;
    Button2: TButton;
    Bevel1: TBevel;
    Label8: TLabel;
    Edit7: TEdit;
    Button3: TButton;
    Edit8: TEdit;
    Button4: TButton;
    Bevel2: TBevel;
    Button5: TButton;
    Button6: TButton;
    ProgressBar1: TProgressBar;
    Label9: TLabel;
    Timer1: TTimer;
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure stopscan;
    procedure Timer1Timer(Sender: TObject);
    procedure winsockevent(var msg:tcmsocketmessage); message WM_USER+1;
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form7: TForm7;

implementation

uses client_main;

//uses client_main;

var ipscanactive:boolean=false;
    st,en,ipi:integer;
    port:word;
    ip:cardinal;
    ipa:array [1..4] of byte absolute ip;
    socks:integer;


{$R *.DFM}

procedure TForm7.Edit1KeyPress(Sender: TObject; var Key: Char);
var tmp:tedit;
label nextedit;
begin
  if (key=#8) then begin
    if tedit(sender).selstart=0 then begin
      if sender=edit2 then tmp:=edit1 else
      if sender=edit3 then tmp:=edit2 else
      if sender=edit4 then tmp:=edit3 else
      if sender=edit5 then tmp:=edit4 else
      tmp:=tedit(sender);
      tedit(tmp).setfocus;
      tedit(tmp).selstart:=3;
    end;
    exit;
  end;
  if tedit(sender).selstart in [0..2] then begin
    if (key='.')or(key=' ') then goto nextedit;
    if not (key in ['0'..'9']) then key:=#0;
  end else if tedit(sender).selstart=3 then begin
nextedit:
    if sender=edit1 then tmp:=edit2 else
    if sender=edit2 then tmp:=edit3 else
    if sender=edit3 then tmp:=edit4 else
    tmp:=tedit(sender);
    tmp.setfocus;
    if key in ['0'..'9'] then begin
      tmp.selstart:=1;
      sendmessage(tmp.handle,WM_CHAR,word(key),0);
    end;
    key:=#0;
  end;
end;

procedure TForm7.Button1Click(Sender: TObject);
begin
  messagedlg('When connect occurs (server is found) if this checkbox is checked then scanner will wait for it to return it''s version information. If not checked, then scanning will be faster and can be used to scan any other servers, for example http - port 80',mtinformation,[mbok],0);
end;

procedure TForm7.Button6Click(Sender: TObject);
begin
  if ipscanactive then stopscan else begin
    if socks<>0 then begin
      messagedlg('Wait for all sockets to close. '+inttostr(socks)+' left.',mterror,[mbok],0);
    end else
      //form7.hide;
      form7.modalresult:=mrok;
  end;
end;

procedure TForm7.Button5Click(Sender: TObject);
var tmp:integer;
begin
  listbox1.Items.Clear;
  tmp:=strtoint(edit1.text);
  if tmp>255 then begin messagedlg('Invalid IP!',mterror,[mbok],0); exit; end;
  ipa[1]:=tmp;
  tmp:=strtoint(edit2.text);
  if tmp>255 then begin messagedlg('Invalid IP!',mterror,[mbok],0); exit; end;
  ipa[2]:=tmp;
  tmp:=strtoint(edit3.text);
  if tmp>255 then begin messagedlg('Invalid IP!',mterror,[mbok],0); exit; end;
  ipa[3]:=tmp;
  tmp:=strtoint(edit4.text);
  if tmp>255 then begin messagedlg('Invalid IP!',mterror,[mbok],0); exit; end;
  ipa[4]:=tmp; st:=tmp;
  tmp:=strtoint(edit5.text);
  if (tmp>255)or(tmp<1) then begin messagedlg('Invalid IP!',mterror,[mbok],0); exit; end;
  en:=tmp;

  tmp:=strtoint(edit6.text);
  if (tmp>32767)or(tmp<1) then begin messagedlg('Invalid Port (1 <= port <= 32767)!',mterror,[mbok],0); exit; end;
  port:=tmp;

  if (ipa[1]=127)and(ipa[2]=0)and(ipa[3]=0) then  en:=st;

  button5.enabled:=false;
  button6.caption:='Cancel';
  ipi:=st;
  progressbar1.min:=st;
  progressbar1.max:=en;
  progressbar1.position:=st;
  label9.caption:=inttostr(ipi);
  ipscanactive:=true;
  timer1.enabled:=true;
  port:=strtoint(edit6.text);
end;

procedure TForm7.Button3Click(Sender: TObject);
var ip:phostent;
    ipc:cardinal;
    ipa:array[1..4]of byte absolute ipc;
begin
  ip:=winsock.gethostbyname(pchar(edit7.text));
  if ip=nil then begin
    //ipc:=winsock.htonl($7F000001) // 127.0.0.1
    edit8.text:='No host';
    exit;
  end else begin
    ipc:=cardinal(pointer(ip^.h_addr_list^)^);
    ipc:=winsock.ntohl(ipc);
  end;
  edit8.text:=inttostr(ipa[4])+'.'+inttostr(ipa[3])+'.'+inttostr(ipa[2])+'.'+inttostr(ipa[1]);
end;

procedure TForm7.Button4Click(Sender: TObject);
var s:string;
    i,j:integer;
label error;
begin
  s:=edit8.text;
  i:=pos('.',s); if i=0 then goto error;
  edit1.text:=copy(s,1,i-1); s[i]:='x'; j:=i+1;
  i:=pos('.',s); if i=0 then goto error;
  edit2.text:=copy(s,j,i-j); s[i]:='x'; j:=i+1;
  i:=pos('.',s); if i=0 then goto error;
  edit3.text:=copy(s,j,i-j); s[i]:='x'; j:=i+1;
  edit4.text:=copy(s,j,length(s)-j+1);
  exit;
error:
  messagedlg('Invalid IP',mterror,[mbok],0);
end;

procedure tform7.stopscan;
begin
  timer1.enabled:=false;
  ipscanactive:=false;
  button5.enabled:=true;
  button6.caption:='Exit';
  progressbar1.Max:=255;
  progressbar1.Position:=progressbar1.Max;
  label9.caption:='0';
end;

function iptostr(p:cardinal):string;
var pa:array[1..4] of byte absolute p;
begin
  result:=inttostr(pa[1])+'.'+inttostr(pa[2])+'.'+inttostr(pa[3])+'.'+inttostr(pa[4]);
end;

procedure TForm7.Timer1Timer(Sender: TObject);
var skt:tsocket;
    sa:SockAddr_in;
//    addr:in_addr;
    a:integer;
    estr:string;
label showerror,cont;
begin
  if ipscanactive=false then begin
//    if socks=0 then begin
//      wsacleanup;
//      timer1.enabled:=false;
//    end;
    exit;
  end;
  if socks>=40 then exit;

  skt:=socket(PF_INET,SOCK_STREAM,IPPROTO_IP);
  sa.sin_port:=htons(port);
  ipa[4]:=ipi;
  sa.sin_addr.S_addr:=ip;
  sa.sin_family:=PF_INET;
  socks:=socks+1;
  wsaasyncselect(skt,form7.handle,WM_USER+1,FD_CONNECT or FD_READ);

  a:=connect(skt,sa,sizeof(sa));
  if a=-1 then begin
    a:=wsagetlasterror; estr:='';
    case a of
      WSAENETDOWN: begin estr:='Network subsystem is down'; goto showerror; end;
      WSAEADDRNOTAVAIL: begin estr:='IP is not available'; goto showerror; end;
      WSAEAFNOSUPPORT: begin estr:='IP is not supported'; goto showerror; end;
      WSAEFAULT: goto showerror;
      WSAENETUNREACH: begin estr:='Network cannot be reached'; goto showerror; end;
      WSAEHOSTUNREACH: begin estr:='Host cannot be reached'; goto showerror; end;
// should be else - WSAENOBUFS: goto showerror;
      WSAEWOULDBLOCK: goto cont;
    else
      socks:=socks-1;
      closesocket(skt);
      exit;
    end;
showerror:
    socks:=socks-1;
    closesocket(skt);
    stopscan;
    messagedlg('Connect error '+inttostr(a)+#10+estr+#10'Scan ended at '+iptostr(ip),mterror,[mbok],0);
    exit;
  end;
cont:
  ipi:=ipi+1;
  if ipi>en then begin stopscan; exit; end;
  progressbar1.Position:=ipi;
  label9.caption:=inttostr(ipi);
end;

procedure Tform7.winsockevent(var msg:tcmsocketmessage);
var sa:sockaddr_in;
    namelen:integer;
    tmp:string[20];
begin
  if msg.SelectError=0 then begin
    if checkbox1.checked then begin
      if msg.SelectEvent=FD_CONNECT then exit else {do not unconnect}
      if msg.SelectEvent=FD_READ then begin
        namelen:=sizeof(sa);
        getpeername(msg.Socket,sa,namelen);
        namelen:=recv(msg.socket,tmp[1],20,0);
        setlength(tmp,namelen-1);
        if (ipa[1]=127)and(ipa[2]=0) then listbox1.Items.add('localhost: R3C v'+tmp)
        else listbox1.Items.add(iptostr(sa.sin_addr.S_addr)+': R3C v'+tmp);
      end;
    end else begin {unchecked}
      if msg.SelectEvent=FD_CONNECT then begin
        namelen:=sizeof(sa);
        getpeername(msg.Socket,sa,namelen);
        if (ipa[1]=127)and(ipa[2]=0) then listbox1.Items.add('localhost: Connected')
        else listbox1.Items.add(iptostr(sa.sin_addr.S_addr)+': Connected');
      end;
    end;
  end;
  closesocket(msg.socket);
  socks:=socks-1;
end;


procedure TForm7.Button2Click(Sender: TObject);
var i,j,cnt:integer;
    s:string;
    tmp:boolean;
begin
  cnt:=0;
  for i:=0 to listbox1.Items.Count-1 do begin
    if listbox1.Selected[i] then begin
      j:=pos(':',listbox1.items.strings[i]);
      s:=copy(listbox1.items.strings[i],1,j-1);
      tmp:=false;
      for j:=0 to form1.combobox1.items.Count-1 do if s=form1.combobox1.items.strings[j] then tmp:=true;
      if tmp=false then begin
        form1.combobox1.items.add(s);
        cnt:=cnt+1;
      end;
    end;
  end;
  messagedlg(inttostr(cnt)+' items added.',mtinformation,[mbok],0);
end;

end.
